#include <sourcemod>
#include <sdktools>
#include <vip_core>

#pragma semicolon 1
#pragma newdecls required

#define VIP_J	"jumps"

public Plugin myinfo =
{
	name = "[VIP] Jumps",
	author = "Tonki_Ton",
	version = "2.1.0"
};

int g_iNoVipJumps,
	g_iJumpsCount[MAXPLAYERS+1];

public void OnPluginStart()
{
	if (VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}

	ConVar hConVar = CreateConVar("no_vip_jumps", "2",	"Количество прыжков у обычных игроков"); hConVar.AddChangeHook(OnCvarChange);
	g_iNoVipJumps = hConVar.IntValue;
}

public void OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(VIP_J);
	}
}

public void OnCvarChange(ConVar hCvar, const char[] sOldValue, const char[] sNewValue)
{
	g_iNoVipJumps = StringToInt(sNewValue);
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_J, INT);
}

public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP)
{
	g_iJumpsCount[iClient] = bIsVIP && VIP_IsClientFeatureUse(iClient, VIP_J) ? VIP_GetClientFeatureInt(iClient, VIP_J):g_iNoVipJumps;
}

public Action OnPlayerRunCmd(int iClient, int &iCurButtons, int &impulse, float vel[3], float angles[3], int &weapon)
{
	if (IsPlayerAlive(iClient))
	{
		static int iLastButtons[MAXPLAYERS+1], iLastFlags[MAXPLAYERS+1], iJumps[MAXPLAYERS+1], iCurFlags;

		iCurFlags = GetEntityFlags(iClient);

		if (iLastFlags[iClient] & FL_ONGROUND && !(iCurFlags & FL_ONGROUND) && !(iLastButtons[iClient] & IN_JUMP) && iCurButtons & IN_JUMP) 
			iJumps[iClient]++;
		else if (iCurFlags & FL_ONGROUND) 
			iJumps[iClient] = 1;
		else if (!(iLastButtons[iClient] & IN_JUMP) && iCurButtons & IN_JUMP && iJumps[iClient] < g_iJumpsCount[iClient])
		{
			iJumps[iClient]++;
			float vVel[3];
			GetEntPropVector(iClient, Prop_Data, "m_vecVelocity", vVel);
			vVel[2] = 300.0;
			TeleportEntity(iClient, NULL_VECTOR, NULL_VECTOR, vVel);
		}
		iLastFlags[iClient] = iCurFlags;
		iLastButtons[iClient]	= iCurButtons;
	}

	return Plugin_Continue;
}